package l08_exceptions;

public class ExtraFeatures {

	static class MyException extends Exception {
		private int number; // 1

		public MyException() {}

		public MyException(String msg) {
			super(msg);
		}

		public MyException(String msg, int number) {
			super(msg); // 1
			this.number = number; // 1
//			super(msg + ", number = " + number); // 2
		}

		public int getNumber() { // 1
			return number;
		}
	}

	private static void f() throws MyException {
		System.out.println("Throwing MyException from f()");
		throw new MyException();
	}

	private static void g() throws MyException {
		System.out.println("Throwing MyException from g()");
		throw new MyException("Originated in g()");
	}

	private static void h() throws MyException {
		System.out.println("Throwing MyException from h()");
		throw new MyException("Originated in h()", 47);
	}

	@FunctionalInterface
	private interface Functional {
		void function() throws MyException;
	}

	static void callFunction(Functional functional) {
		try {
			functional.function();
		} catch (MyException e) {
			System.out.println("e.val() = " + e.getNumber()); // 1
			e.printStackTrace();
		}
		System.out.println();
	}

	public static void main(String[] args) {
		System.out.println();
		callFunction(ExtraFeatures::f);
		callFunction(ExtraFeatures::g);
		callFunction(ExtraFeatures::h);
	}
}
