package l08_exceptions;

public class FinallyReturn {

	public static void main(String[] args) {
		System.out.println(foo(5));
		System.out.println();
		System.out.println(foo(0));
	}

//	A return statement with an Expression attempts to transfer control to the
//	invoker of the method that contains it; the value of the Expression becomes
//	the value of the method invocation.

//	The preceding descriptions say "attempts to transfer control" rather than
//	just "transfers control" because if there are any try statements within the
//	method or constructor whose try blocks contain the return statement, then
//	any finally clauses of those try statements will be executed, in order,
//	innermost to outermost, before control is transferred to the invoker of the
//	method or constructor.

	private static int foo(int n) {
		try {
//	Here exception is thrown (if n == 0) and it is suppressed by finally
//	block so always 42 is returned
			System.out.println("n = " + n);
			if(n == 0) throw new RuntimeException();
			return n;
		} catch(RuntimeException e) {
			System.out.println("Exception caught");
		} finally {
			return 42;
		}
	}
}

