package l08_exceptions;

public class HtmlTag implements AutoCloseable {
	private final String tag;

	public HtmlTag(String tag) {
		this.tag = tag;
		System.out.println("<" + tag + ">");
	}

	private static void body(String body) {
		System.out.println(body);
	}

	@Override
	public void close() {
		System.out.println("</" + tag + ">");
	}

	public static void main(String[] args) {

		try(HtmlTag html = new HtmlTag("html");
			HtmlTag h1 = new HtmlTag("h1");
			HtmlTag em = new HtmlTag("em")
		) {
			body("Some text");
			body("Some other text");
		}
	}
}

