package l08_exceptions;

import java.io.*;

public class TryWithResources {

	public static void main(String[] args){
		// Using try-with-resources / multiple resources
		try(BufferedReader fileReader = new BufferedReader(new FileReader("testing.txt"));
			BufferedWriter fileWriter = new BufferedWriter(new FileWriter("output.txt"))
		) {
			String line;
			while((line = fileReader.readLine()) != null) {
				fileWriter.write(line);
				fileWriter.newLine();
			}
		} catch(IOException exception) {
			exception.printStackTrace();
		}
	}
}
